/*
    NUT nutrition software 
    Copyright (C) 2005 Jim Jozwiak.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

int Abbrev_Count = 474;
char *Abbreviations[] = {"ALL PURPOSE","ALLPURP","ALUMINUM","AL","AND","&","APPLE","APPL","APPLES","APPLS","APPLESAUCE","APPLSAUC","APPROXIMATE","APPROX","APPROXIMATELY","APPROX","ARM AND BLADE","ARM&BLD","ARTIFICIAL","ART","ASCORBIC ACID","VIT C","ASPARTAME","ASPRT","ASPARTAME-SWEETENED","ASPRT-SWTND","BABY FOOD","BABYFD","BAKED","BKD","BARBEQUED","BBQ","BASED","BSD","BEANS","BNS","BEEF","BF","BEVERAGE","BEV","BOILED","BLD","BONELESS","BNLESS","BOTTLED","BTLD","BOTTOM","BTTM","BRAISED","BRSD","BREAKFAST","BRKFST","BROILED","BRLD","BUTTERMILK","BTTRMLK","CALCIUM","CA","CALORIE","CAL","CALORIES","CAL","CANNED","CND","CARBONATED","CARB","CENTER","CNTR","CEREAL","CRL","CHEESE","CHS","CHICKEN","CHICK","CHOCOLATE","CHOC","CHOICE","CHOIC","CHOLESTEROL","CHOL","CHOLESTEROL-FREE","CHOL-FREE","CHOPPED","CHOPD","CINNAMON","CINN","COATED","COATD","COCONUT","COCNT","COMMERCIAL","COMM","COMMERCIALLY","COMMLY","COMMODITY","CMDTY","COMPOSITE","COMP","CONCENTRATE","CONC","CONCENTRATED","CONCD","CONDENSED","COND","CONDIMENT","CONDMNT","CONDIMENTS","CONDMNT","COOKED","CKD","COTTONSEED","CTTNSD","CREAM","CRM","CREAMED","CRMD","DARK","DK","DECORTICATED","DECORT","DEHYDRATED","DEHYD","DESSERT","DSSRT","DESSERTS","DSSRT","DILUTED","DIL","DOMESTIC","DOM","DRAINED","DRND","DRESSING","DRSNG","DRINK","DRK","DRUMSTICK","DRUMSTK","ENGLISH","ENG","ENRICHED","ENR","EQUAL","EQ","EVAPORATED","EVAP","EXCEPT","XCPT","EXTRA","EX","FLANK STEAK","FLANKSTK","FLAVORED","FLAV","FLOUR","FLR","FOOD","FD","FORTIFIED","FORT","FRENCH","FRIED,FRENCH FR","FRENCH FRIES","FRENCH FR","FRESH","FRSH","FROSTED","FRSTD","FROSTING","FRSTNG","FROZEN","FRZ","GRADES","GRDS","GRAM","GM","GREEN","GRN","GREENS","GRNS","HEATED","HTD","HEAVY","HVY","HI-MEAT","HI-MT","HIGH","HI","HOUR","HR","HYDROGENATED","HYDR","IMITATION","IMITN","IMMATURE","IMMAT","IMPORTED","IMP","INCLUDE","INCL","INCLUDES","INCL","INCLUDING","INCL","INFANT","INF","INGREDIENT","ING","INSTANT","INST","JUICE","JUC","JUNIOR","JR","KERNELS","KRNLS","LARGE","LRG","LEAN","LN","LEAN","ONLY,LN","LEAVENED","LVND","LIGHT","LT","LIQUID","LIQ","LOW","LO","LOW FAT","LOFAT","MARSHMALLOW","MARSHMLLW","MASHED","MSHD","MAYONNAISE","MAYO","MEDIUM","MED","MESQUITE","MESQ","MINUTES","MIN","MIXED","MXD","MOISTURE","MOIST","NATURAL","NAT","NEW ZEALAND","NZ","NONCARBONATED","NONCARB","NONFAT DRY MILK","NFDM","NONFAT DRY MILK SOLIDS","NFDMS","NONFAT MILK SOLIDS","NFMS","NOT FURTHER SPECIFIED","NFS","NUTRIENTS","NUTR","NUTRITION","NUTR","OUNCE","OZ","PACK","PK","PAR FRIED","PAR FR","PARBOILED","PARBLD","PARTIAL","PART","PARTIALLY","PART","PARTIALLY FRIED","PAR FR","PASTEURIZED","PAST","PEANUT","PNUT","PEANUTS","PNUTS","PHOSPHATE","PO4","PHOSPHORUS","P","PINEAPPLE","PNAPPL","PLAIN","PLN","PORTERHOUSE","PRTRHS","POTASSIUM","K","POWDER","PDR","POWDERED","PDR","PRECOOKED","PRECKD","PREHEATED","PREHTD","PREPARED","PREP","PROCESSED","PROC","PRODUCT CODE","PROD CD","PROPIONATE","PROP","PROTEIN","PROT","PUDDING","PUDD","PUDDINGS","PUDD","READY-TO-BAKE","RTB","READY-TO-COOK","RTC","READY-TO-DRINK","RTD","READY-TO-EAT","RTE","READY-TO-FEED","RTF","READY-TO-HEAT","RTH","READY-TO-SERVE","RTS","READY-TO-USE","RTU","RECONSTITUTED","RECON","REDUCED","RED","REDUCED-CALORIE","RED-CAL","REFRIGERATED","REFR","REGULAR","REG","REHEATED","REHTD","REPLACEMENT","REPLCMNT","RESTAURANT-PREPARED","REST-PREP","RETAIL","RTL","ROAST","RST","ROASTED","RSTD","ROUND","RND","SANDWICH","SNDWCH","SAUCE","SAU","SCALLOPED","SCALLPD","SCRAMBLED","SCRMBLD","SEED","SD","SELECT","SEL","SHANK AND SIRLOIN","SHK&SIRL","SHORT","SHRT","SHOULDER","SHLDR","SIMMERED","SIMMRD","SKIN","SKN","SMALL","SML","SODIUM","NA","SOLIDS","SOL","SOLUTION","SOLN","SOYBEAN","SOYBN","SPECIAL","SPL","SPECIES","SP","SPREAD","SPRD","STANDARD","STD","STEAMED","STMD","STEWED","STWD","STICK","STK","STICKS","STKS","STRAINED","STR","SUBSTITUTE","SUB","SUMMER","SMMR","SUPPLEMENT","SUPP","SWEET","SWT","SWEETENED","SWTND","SWEETENER","SWTNR","TEASPOON","TSP","THOUSAND","1000","TOASTED","TSTD","TODDLER","TODD","UNCOOKED","UNCKD","UNCREAMED","UNCRMD","UNDILUTED","UNDIL","UNENRICHED","UNENR","UNHEATED","UNHTD","UNPREPARED","UNPREP","UNSPECIFIED","UNSPEC","UNSWEETENED","UNSWTND","VARIETY","VAR","VARIETIES","VAR","VEGETABLE","VEG","VEGETABLES","VEG","VITAMIN","VIT","VITAMIN A","VIT A","VITAMIN C","VIT C","WATER","H2O","WHITENER","WHTNR","WHOLE","WHL","WINTER","WNTR","WITH","W/","WITHOUT","WO/","YELLOW","YEL"};

